package main;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.Serializable;

import javax.annotation.processing.Filer;

public class Instrument implements Music, Serializable {
//public class Instrument implements Music {
	
	private String name;
	private boolean electric;

	public Instrument() {
	}

	public Instrument(String name, boolean electric) {
		this.name = name;
		this.electric = electric;
	}
	
	public String getMusic() {
		if (electric) {
			return "electric";
		} else {
			return "acoustic";
		}
	}
	
	public String getLoudness() {
		if (electric) {
			return "loud";
		} else {
			return "not loud";
		}
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;;
	}
	
	public void saveToFile(String filename) {
		File f = new File(filename);
		try {
			PrintStream out = new PrintStream(f);
			out.println(this.name);
			if (electric) {
				out.println("electric");
			} else {
				out.println("acoustic");
			}
		} catch (FileNotFoundException e) {
		}
	}
	
	public static Instrument readFromFile(String filename) {
		Instrument instrument = new Instrument();
//		File f = new File(filename);
		try {
			BufferedReader in = new BufferedReader(new FileReader(filename));
			instrument.setName(in.readLine());
			String electric = in.readLine();
			if (electric.equals("electric")) {
				instrument.setElectric(true);
			} else {
				instrument.setElectric(false);
			}
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
		
		return instrument;
	}

	public static Instrument readFromKeyboard() {
		Instrument instrument = new Instrument();
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader (System.in));
			System.out.print("Read instrument name: ");
			instrument.setName(in.readLine());
			System.out.print("Read instrument type: ");
			String electric = in.readLine();
			if (electric.equals("electric")) {
				instrument.setElectric(true);
			} else {
				instrument.setElectric(false);
			}
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
		
		return instrument;
	}

	public void serializeToFile(String filename) {
		File f = new File(filename);
		try {
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(f));
//			out.writeObject("A string...");
//			out.writeObject(new Double(23.4));
			out.writeObject(this);
//			out.close();
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
	}
	
	public static Instrument deserializeFromFile(String filename) {
		File f = new File(filename);
		Instrument instrument = new Instrument();
		try {
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(f));
//			String s = (String)in.readObject();
//			System.out.println(s);
//			Double d = (Double)in.readObject();
//            System.out.println(d);
			
			// THIS was/is OK; something else was wrong
			// The mystery continues until Dec 28 ;)
			instrument = (Instrument)in.readObject();
//			in.close();
		} catch (FileNotFoundException e) {
//		    System.err.println("File not found exception");
		} catch (IOException e) {
//            System.err.println("IO exception");
		} catch (ClassNotFoundException e) {
//            System.err.println("Class not found exception");
		}
		return instrument;
	}
	
    public boolean isElectric() {
        return electric;
    }

    public void setElectric(boolean electric) {
        this.electric = electric;
    }

    @Override
    public String toString() {
    	return this.getName();
    }
}
