package main;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

import javax.annotation.processing.Filer;

public class Instrument implements Music {
	
	private String name;
	private boolean electric;

	public Instrument() {
	}

	public Instrument(String name, boolean electric) {
		this.name = name;
		this.electric = electric;
	}
	
	public String getMusic() {
		if (electric) {
			return "electric";
		} else {
			return "acoustic";
		}
	}
	
	public String getLoudness() {
		if (electric) {
			return "loud";
		} else {
			return "not loud";
		}
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;;
	}
	
	public void saveToFile(String filename) {
		File f = new File(filename);
		try {
			PrintStream out = new PrintStream(f);
			out.println(this.name);
			if (electric) {
				out.println("electric");
			} else {
				out.println("acoustic");
			}
		} catch (FileNotFoundException e) {
		}
	}
	
	public Instrument readFromFile(String filename) {
		Instrument instrument = new Instrument();
//		File f = new File(filename);
		try {
			BufferedReader in = new BufferedReader(new FileReader(filename));
			instrument.setName(in.readLine());
			String electric = in.readLine();
			if (electric.equals("electric")) {
				instrument.setElectric(true);
			} else {
				instrument.setElectric(false);
			}
		} catch (FileNotFoundException e) {
		} catch (IOException e) {
		}
		
		return instrument;
	}

    public boolean isElectric() {
        return electric;
    }

    public void setElectric(boolean electric) {
        this.electric = electric;
    }

}
